﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

// used the example code from here: https://docs.unity3d.com/ScriptReference/EventSystems.IPointerEnterHandler.html
public class HoverScript : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler
{
    private GameObject panel;
    private float width;
    private float height;
    private bool hovering;

    void Update()
    {
        if(hovering)
        {
            panel.transform.position = new Vector3(Input.mousePosition.x + (width / 2) + 15, Input.mousePosition.y - (height / 2) - 15, Input.mousePosition.z);
        } else
        {
            panel.transform.position = new Vector3(-200, -200, 0);
        }
    }

    //Detect if the Cursor starts to pass over the GameObject
    public void OnPointerEnter(PointerEventData pointerEventData)
    {
        hovering = true;
    }

    //Detect when Cursor leaves the GameObject
    public void OnPointerExit(PointerEventData pointerEventData)
    {
        hovering = false;
    }

    public void setPanel(GameObject h)
    {
        panel = h;
        width = panel.GetComponent<RectTransform>().sizeDelta.x;
        height = panel.GetComponent<RectTransform>().sizeDelta.y;
    }
}
